<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: index.php
| CVS Version: 1.00
| Author: Digitanium
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

if (!checkrights("APWR") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }

if (file_exists(INFUSIONS."admin_reset/locale/".$settings['locale'].".php")) {
	include INFUSIONS."admin_reset/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."admin_reset/locale/English.php";
}

if (isset($_POST['reset_admin'])) {
	require_once INCLUDES."sendmail_include.php";
	$reset_message = stripinput($_POST['reset_message']);
	$new_login_password = "";
	$new_admin_password = "";
	$chars = "abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ123456789-_!@";
	$char_count = strlen($chars) - 1;
	$sent_emails = array();
	$unsent_emails = array();
	if (isset($_POST['user']) && isnum($_POST['user'])) {
		$result = dbquery("SELECT user_id, user_name, user_email, user_level FROM ".DB_USERS." WHERE user_id='".$_POST['user']."'");
		$data = dbarray($result);
		for ($i = 0; $i < 12; $i++) {
			$new_admin_password .= substr($chars, mt_rand(0, $char_count), 1);
		}
		if (isset($_POST['reset_login'])) {
			for ($i = 0; $i < 12; $i++) {
				$new_login_password .= substr($chars, mt_rand(0, $char_count), 1);
			}
			$message = str_replace(array("[USER_NAME]", "[NEW_PASS]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_login_password, $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_109']);
		} else {
			$message = str_replace(array("[USER_NAME]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_108']);
		}
		if (sendemail($data['user_name'], $data['user_email'], $userdata['user_name'], $userdata['user_email'], $locale['apw_107'].$settings['sitename'], $message)) {
			$result2 = dbquery("UPDATE ".DB_USERS." SET ".(isset($_POST['reset_login']) ? "user_password='".md5(md5($new_login_password))."', " : "")."user_admin_password='".md5(md5($new_admin_password))."' WHERE user_id='".$data['user_id']."'");
			$sent_emails[] = $data['user_name'];
		} else {
			$unsent_emails[] = $data['user_name'];
		}
	} elseif (isset($_POST['user']) && $_POST['user'] == "all") {
		$result = dbquery("SELECT user_id, user_name, user_email, user_level FROM ".DB_USERS." WHERE user_level>'101' ORDER BY user_level DESC, user_name");
		while ($data = dbarray($result)) {
			for ($i = 0; $i < 12; $i++) {
				$new_admin_password .= substr($chars, mt_rand(0, $char_count), 1);
			}
			if (isset($_POST['reset_login'])) {
				for ($i = 0; $i < 12; $i++) {
					$new_login_password .= substr($chars, mt_rand(0, $char_count), 1);
				}
				$message = str_replace(array("[USER_NAME]", "[NEW_PASS]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_login_password, $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_109']);
			} else {
				$message = str_replace(array("[USER_NAME]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_108']);
			}
			if (sendemail($data['user_name'], $data['user_email'], $userdata['user_name'], $userdata['user_email'], $locale['apw_107'].$settings['sitename'], $message)) {
				$result2 = dbquery("UPDATE ".DB_USERS." SET ".(isset($_POST['reset_login']) ? "user_password='".md5(md5($new_login_password))."', " : "")."user_admin_password='".md5(md5($new_admin_password))."' WHERE user_id='".$data['user_id']."'");
				$sent_emails[] = $data['user_name'];
			} else {
				$unsent_emails[] = $data['user_name'];
			}
			$new_login_password = "";
			$new_admin_password = "";
		}
	} elseif (isset($_POST['user']) && $_POST['user'] == "sa") {
		$result = dbquery("SELECT user_id, user_name, user_email, user_level FROM ".DB_USERS." WHERE user_level='103' ORDER BY user_name");
		while ($data = dbarray($result)) {
			for ($i = 0; $i < 12; $i++) {
				$new_admin_password .= substr($chars, mt_rand(0, $char_count), 1);
			}
			if (isset($_POST['reset_login'])) {
				for ($i = 0; $i < 12; $i++) {
					$new_login_password .= substr($chars, mt_rand(0, $char_count), 1);
				}
				$message = str_replace(array("[USER_NAME]", "[NEW_PASS]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_login_password, $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_109']);
			} else {
				$message = str_replace(array("[USER_NAME]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_108']);
			}
			if (sendemail($data['user_name'], $data['user_email'], $userdata['user_name'], $userdata['user_email'], $locale['apw_107'].$settings['sitename'], $message)) {
				$result2 = dbquery("UPDATE ".DB_USERS." SET user_admin_password='".md5(md5($new_admin_password))."' WHERE user_id='".$data['user_id']."'");
				$sent_emails[] = $data['user_name'];
			} else {
				$unsent_emails[] = $data['user_name'];
			}
			$new_login_password = "";
			$new_admin_password = "";
		}
	} elseif (isset($_POST['user']) && $_POST['user'] == "a") {
		$result = dbquery("SELECT user_id, user_name, user_email, user_level FROM ".DB_USERS." WHERE user_level='102' ORDER BY user_name");
		while ($data = dbarray($result)) {
			for ($i = 0; $i < 12; $i++) {
				$new_admin_password .= substr($chars, mt_rand(0, $char_count), 1);
			}
			if (isset($_POST['reset_login'])) {
				for ($i = 0; $i < 12; $i++) {
					$new_login_password .= substr($chars, mt_rand(0, $char_count), 1);
				}
				$message = str_replace(array("[USER_NAME]", "[NEW_PASS]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_login_password, $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_109']);
			} else {
				$message = str_replace(array("[USER_NAME]", "[NEW_ADMIN_PASS]", "[ADMIN]", "[RESET_MESSAGE]"), array($data['user_name'], $new_admin_password, $userdata['user_name'], $reset_message), $locale['apw_108']);
			}
			if (sendemail($data['user_name'], $data['user_email'], $userdata['user_name'], $userdata['user_email'], $locale['apw_107'].$settings['sitename'], $message)) {
				$result2 = dbquery("UPDATE ".DB_USERS." SET ".(isset($_POST['reset_login']) ? "user_password='".md5(md5($new_login_password))."', " : "")."user_admin_password='".md5(md5($new_admin_password))."' WHERE user_id='".$data['user_id']."'");
				$sent_emails[] = $data['user_name'];
			} else {
				$unsent_emails[] = $data['user_name'];
			}
			$new_login_password = "";
			$new_admin_password = "";
		}
	}
	opentable($locale['apw_110']);
	echo "<div class='tbl' width='400'>\n";
	echo $locale['apw_111'].count($sent_emails)."<br /><br />\n";
	foreach($sent_emails as $user_name) {
		echo $user_name."<br />";
	}
	echo "<br />".$locale['apw_112'].count($unsent_emails)."<br /><br />\n";
	foreach($unsent_emails as $user_name) {
		echo $user_name."<br />";
	}
	echo "<br /><a href='".FUSION_SELF.$aidlink."'>".$locale['apw_113']."</a>\n";
	echo "</div>\n";
	closetable();
}

opentable($locale['apw_admin1']);
echo "<form name='admin_reset' method='post' action='".FUSION_SELF.$aidlink."'>\n";
echo "<div class='tbl' style='text-align:center'>\n";
echo $locale['apw_100']."<br /><br />\n";
echo "<select name='user' class='textbox'>\n";
echo "<option value='all'>".$locale['apw_101']."</option>\n";
echo "<option value='sa'>".$locale['apw_102']."</option>\n";
echo "<option value='a'>".$locale['apw_103']."</option>\n";
$result = dbquery("SELECT user_id, user_name, user_level FROM ".DB_USERS." WHERE user_level>'101' ORDER BY user_level DESC, user_name");
while ($data = dbarray($result)) {
	echo "<option value='".$data['user_id']."'>".$data['user_name']." ".($data['user_level'] == 102 ? "(A)" : "(SA)")."</option>\n";
}
echo "</select><br /><br />\n";
echo $locale['apw_104'].":<br />\n";
echo "<textarea name='reset_message' cols='70' rows='4' class='textbox'></textarea><br /><br />\n";
echo "<label><input type='checkbox' name='reset_login' value='1' /> ".$locale['apw_105']."</label><br /><br />\n";

echo "<input type='submit' name='reset_admin' value='".$locale['apw_106']."' class='button' />\n";
echo "</div>\n";
echo "</form>\n";
closetable();

require_once THEMES."templates/footer.php";
?>